Crypto++

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
AutoSeededX917RNG< BLOCK_CIPHER > Class Template Reference

RNG from ANSI X9.17 Appendix C, seeded using an OS provided RNG. More...

`#include <osrng.h>`

Inheritance diagram for AutoSeededX917RNG< BLOCK_CIPHER >:

List of all members.

## Public Member Functions

| AutoSeededX917RNG (bool blocking=false, bool autoSeed=true)
| use blocking to choose seeding with BlockingRng or NonblockingRng. the parameter is ignored if only one of these is available
void | Reseed (bool blocking=false, const byte *additionalEntropy=NULL, size_t length=0)
void | Reseed (const byte *key, size_t keylength, const byte *seed, const byte *timeVector)
bool | CanIncorporateEntropy () const
| returns true if IncorporateEntropy is implemented
void | IncorporateEntropy (const byte *input, size_t length)
| update RNG state with additional unpredictable values
void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| generate random bytes as input to a BufferedTransformation
virtual byte | GenerateByte ()
| generate new random byte and return it
virtual unsigned int | GenerateBit ()
| generate new random bit and return it
virtual word32 | GenerateWord32 (word32 a=0, word32 b=0xffffffffL)
| generate a random 32 bit word in the range min to max, inclusive
virtual void | GenerateBlock (byte *output, size_t size)
| generate random array of bytes
virtual void | DiscardBytes (size_t n)
| generate and discard n bytes
template<class IT >
void | Shuffle (IT begin, IT end)
| randomly shuffle the specified array, resulting permutation is uniformly distributed
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Detailed Description

### template<class BLOCK_CIPHER>
class AutoSeededX917RNG< BLOCK_CIPHER >

RNG from ANSI X9.17 Appendix C, seeded using an OS provided RNG.

Definition at line 97 of file osrng.h.

## Member Function Documentation

virtual unsigned int RandomNumberGenerator::GenerateBit | ( |  | ) | `[virtual, inherited]`

generate new random bit and return it

Default implementation is to call GenerateByte() and return its lowest bit.

Reimplemented in PublicBlumBlumShub.

The documentation for this class was generated from the following file:

- osrng.h